class Locmare.FilerModule.BodyModule.FileBodyModule.FileItemModule.IconItemColumnModule.Base extends Backbone.View
  tagName: 'div'
  
  initialize: (options) ->
    @file_item = options.file_item
    @my_manifest = options.my_manifest
    @item = options.item
    @column_name = 'icon'
    @el.className = 'filer-item-' + @column_name
  
  render_column: () ->
    args = {'item_column': this}
    template = _.template($("#" + @column_template_name()).html())
    this.$el.html(template(args))
    this
  
  render_item: () ->
    args = {'item_column': this}
    template = _.template($("#" + @item_template_name()).html())
    this.$el.html(template(args))
    this
  
  url: () ->
    controller = Manifest.manifest().controllers[@item.table_name()]
    action = controller.actions['show']
    params = {
      controller: controller,
      action: action,
      id: @item.get('id'),
      format: 'prof'
    }
    action.url(params)
  
  click: () ->
    @trigger('click:prof', @url())
  
  filer: () ->
    @file_item.filer()
  
  manifest: () ->
    @filer().manifest
  
  item_name: () ->
    @filer().item_name
  
  column_template_dir: () ->
    @filer().template_dir + 'item_column-'
  
  column_template_file_name: () ->
    raise "undefined column_template_file_name\n"
  
  column_template_name: () ->
    @column_template_dir() + @column_template_file_name()
  
  item_template_dir: () ->
    @filer().template_dir + 'icon-'
  
  item_template_file_name: () ->
    raise "undefined item_template_file_name\n"
  
  item_template_name: () ->
    @item_template_dir() + @item_template_file_name()
  
