class Locmare.FormModule.ExtendField extends Backbone.View
  tagName: 'div'
  className: 'extend-field'
  
  initialize: (options) ->
    @form = options.form
    @field_name = options.field_name
    @field_manifest = options.field_manifest
    @label = Locmare.FormModule.FieldModule.LabelFactory.factory this, @field_manifest.label
    @tag = Locmare.FormModule.FieldModule.TagFactory.factory this, @field_manifest.tag
    @helpers = new Locmare.FormModule.FieldModule.Helpers({field: this, field_manifest: @field_manifest})
    @rb = @row_break()
    @on('change', @change)
    item = @item()
    @listenTo(item, 'resize', @refresh)
    @listenTo(item, 'move', @refresh)
    @listenTo(item, 'sort', @refresh)
  
  render: () ->
    this.$el.html('')
    this.$el.append(@label.render().el) if not @label.hidden()
    this.$el.append(@tag.render().el)
    this.$el.append(@helpers.render().el)
    this
  
  refresh: () ->
    @tag.render()
    @helpers.refresh()
  
  change: () ->
    @set(@val(), {silent: true})
    @item().trigger('input:' + @field_name)
    @item().trigger('input', this)
    
  item: () ->
    @form.item
  
  val: () ->
    @tag.val()
  
  value: () ->
    @item().get(@field_manifest.column_name())
  
  set: (v, opt = null) ->
    a = {}
    a[@field_manifest.column_name()] = v
    @item().set(a, opt)
  
  unset: (opt = null) ->
    a = {}
    a[@field_manifest.column_name()] = undefined
    @item().set(a, {unset: true})
  
  options: (tag_options = {}) ->
    tag_options
  
  form_field_name: () ->
    @form.form_field_name @field_name
  
  form_name: () ->
    @form.form_name
  
  row_break: () ->
    if @field_manifest.row_break
      new Tag.Div({
        content: null,
        class_name: 'row_break'
      })
    else
      null
  
