class Locmare.FormModule.FieldModule.TagModule.Base extends Backbone.View
  tagName: 'input'
  
  initialize: (options) ->
    @field = options.field
    @tag_manifest = options.tag_manifest
    @visible = true
    
  form_field_name: () ->
    @field.form_field_name()
  
  val: () ->
    if Pettanr.is_blank(this.$el.val())
      null
    else
      this.$el.val()
  
  type: () ->
    null
  
  value: () ->
    @field.value()
  
  attr: () ->
    r = {
      name: @form_field_name(),
    }
    # _.extend(r, @options())
    if @type()
      r['type'] = @type()
    if !_.isEmpty(@style())
      r['style'] = Pettanr.to_style(@style())
    r
  
  style: () ->
    r = {}
    if @visible
      #r['style'] = 'display: inline;'
    else
      r['display'] = 'none'
    r
  
  show: () ->
    @visible = true
    @render()
  
  hide: () ->
    @visible = false
    @render()
  
  options: () ->
    @tag_manifest.options
  
  form: () ->
    @field.form
  
  manifest: () ->
    @form().manifest
  
  form_name: () ->
    @form().form_name
  
  item: () ->
    @form().item
  
