class Manifest.ModelModule.Association extends ManifestBase.Values
  
  set_default: () ->
    super()
    @values['belongs_to'] ||= {}
    @values['has_many'] ||= {}
    @values['has_one'] ||= {}
    
  init: () ->
    super()
    @belongs_to = ManifestBase.load_name_values this, @values, 'belongs_to', Manifest.ModelModule.AssociationModule.BelongsTo
    @has_many = ManifestBase.load_name_values this, @values, 'has_many', Manifest.ModelModule.AssociationModule.HasMany
    @has_one = ManifestBase.load_name_values this, @values, 'has_one', Manifest.ModelModule.AssociationModule.HasOne
  
  item_name: () ->
    @parent.item_name()
  
  parent_models: () ->
    _.map _belongs_to, (belongs_to_manifest, name) =>
      pm = @parent.classify()
      next if not pm.is_element()
      if pm.my_peta.type == 'element'
        next if not belongs_to_manifest.model.my_peta.type == 'root'
      if pm.my_peta.type == 'leaf'
        next if not belongs_to_manifest.model.my_peta.type == 'binder'
  
  child_element_name: (child_model) -> 
    if @is_has_one(child_model)
      child_model.item_name()
    else
      child_model.table_name()
  
  is_has_one: (child_model) ->
    if @has_one[child_model.item_name()]
      true
    else
      false
  
class Manifest.ModelModule.AssociationModule
