class Pettanr.License extends Peta.SystemResource
  
  @singular: () ->
    'License'
  
  @plural: () ->
    'Licenses'
  
  defaults: {
    id: null
  } 
  
  license_group: () ->
    new Pettanr.Cache.Retriever(Pettanr.LicenseGroup, @get('license_group_id'))
  
  system_picture: () ->
    new Pettanr.Cache.Retriever(Pettanr.SystemPicture, @get('system_picture_id'))
  
  symbol_option: () ->
    retriever = @system_picture()
    @listenTo(retriever, 'retrieve', @retrieve_symbol)
    retriever.retrieve()
  
  retrieve_symbol: (item) -> 
    @trigger('ready:symbol', item.tmb_opt_img_tag())
  
  caption_with_group: () ->
    retriever = @license_group()
    @listenTo(retriever, 'retrieve', @retrieve_license_group)
    retriever.retrieve()
  
  retrieve_license_group: (license_group) -> 
    caption = license_group.escape('caption') + '/' + @escape('caption')
    @trigger('ready:caption', caption)
  
  is_own: () ->
    true
  
  initialize: (attr = {}, options = {}) ->
    super(attr, options)
  
