class ComicsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_action :authenticate_reader, :only => [
      :index, :show, :play, :by_story, :by_author
    ]
    before_action :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_story
    filer_list
  end
  
  def by_author
    filer_list
  end
  
  def show_html_format format
    format.html {
      @play_list = Locmare::ListGroup.list(
        'comic_stories', 'by_comic', @operators, 
        {:id => @item.id, :page_size => -1}  # set no limit options
      )
    }
  end
  
  def show
    set_show
    respond_to do |format|
      show_html_format format
      show_prof_format format
      show_json_format format
      format.atom 
      format.rss 
    end
  end
  
  def play
    set_play
    @finder.per(-1)    # no limit no pager
    play_list
    respond_to do |format|
      format.html {
        if @item.own? @operators
          @new_story_items = assist_items('home', 'stories', finder: :find_private, param: @operators)
        end
      }
      list_json_format @finder, format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default 
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = @item.permit_params params
    @item.overwrite @operators
    render_create
  end
  
  def update
    set_edit
    @my_model_class.fold_extend_settings params[@my_model_class.item_name]
    @item.attributes = @item.permit_params params
    @item.overwrite @operators
    render_update
  end
  
  def destroy
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    render_destroy '/home/' + @item.path_name
  end
  
end
