class StorySheetsController < ApplicationController
  if Manifest.manifest.magic_numbers['run_mode'] == 0
    before_action :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  else
    before_action :authenticate_reader, :only => [
      :index, :show, :by_story, :by_sheet, :by_author
    ]
    before_action :authenticate_user, :only => [:new, :create, :edit, :update, :destroy]
    before_action :authenticate_author, :only => [:new, :create, :edit, :update, :destroy]
  end
  
  def index
    filer_list
  end
  
  def by_story
    filer_list
  end
  
  def by_sheet
    filer_list
  end
  
  def by_author
    filer_list
  end
  
  def show
    set_show
    respond_to do |format|
      show_prof_format format
      show_json_format format
    end
  end
  
  def new
    form_new
  end
  
  def edit
    form_edit
  end
  
  def create
    set_model
    @item = @my_model_class.new
    @item.supply_default
    @item.attributes = @item.permit_params params
    @item.overwrite @operators
    @binder = @my_model_class.binder_model.edit(@item.binder_id, @operators) if @item.binder_id
    @panel = @my_model_class.destination_model.show(@item.destination_id, @operators) if @item.destination_id
    
    leaf_render_create play_story_path(@binder)
  end
  
  def update
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    ot = @item.t
    @item.attributes = @item.permit_params params
    @item.overwrite @operators
    @binder = @my_model_class.binder_model.edit(@item.binder_id, @operators) if @item.binder_id
    # no check permission for destination
    # swapable hidden panel
    #@panel = @my_model_class.destination_model.show(@item.destination_id, @operators) if @item.destination_id
    
    leaf_render_update ot, play_story_path(@binder)
  end
  
  def destroy
    set_model
    @item = @my_model_class.edit(params[:id], @operators)
    @binder = @my_model_class.binder_model.edit(@item.binder_id, @operators) if @item.binder_id
    render_destroy play_story_path(@binder)
  end
  
end
