class ResourcePicturePicture < Peta::Item
  load_manifest
  belongs_to :original_picture
  belongs_to :resource_picture
  belongs_to :picture
  
  scope :find_index, -> do
    self
  end
  
  scope :find_by_original_picture, -> (original_picture_id) do 
    find_index.where(original_picture_id: original_picture_id)
  end
  
  scope :find_by_resource_picture, -> (resource_picture_id) do 
    find_index.where(resource_picture_id: resource_picture_id)
  end
  
  scope :find_by_picture, -> (picture_id) do 
    find_index.where(picture_id: picture_id)
  end
  
  def symbol_option
    self.picture.tmb_opt_img_tag
  end
  
end
