require_dependency "editor/panel_dock/bay"
require_dependency "editor/panel_dock/board"
module Editor
  module EditorModule
    class PanelDock < Dock
      include DockModule
      attr_accessor :tabs
      def initialize parent
        super
        tab = RootBay.new(self, 0, 'panel')
        add_tab tab, TabModule::RootBayLabel.new(tab, 'panel'), 
          TabModule::RootBayBody.new(tab)
        
        tab = ElementBay.new(self, 1, 'elements')
        add_tab tab, TabModule::ElementBayLabel.new(tab, 'elements'), 
          TabModule::ElementBayBody.new(tab)
        
        tab = ScenarioBay.new(self, 2, 'scenario')
        add_tab tab, TabModule::ScenarioBayLabel.new(tab, 'scenario'), 
          TabModule::ScenarioBayBody.new(tab)
        
        tab = PriorityBay.new(self, 3, 'priority')
        add_tab tab, TabModule::PriorityBayLabel.new(tab, 'priority'), 
          TabModule::PriorityBayBody.new(tab)
        
        tab = NewBay.new(self, 4, 'new')
        add_tab tab, TabModule::NewBayLabel.new(tab, 'new'), 
          TabModule::NewBayBody.new(tab)
        
      end
      
      def template_dir
        @parent.template_dir + 'panel_dock/'
      end
      
      def template_file_name
        'panel_dock'
      end
      
      def dom_id
        self.editor.dom_id + '-dock'
      end
      
      def dom_class
        self.editor.dom_class + '-dock'
      end
      
      def dom_labels_class
        self.dom_class + '-labels'
      end
      
    end
    
  end
end
