module Locmare
  module FormModule
    module FieldModule
      module LabelModule
        class Base
          attr :field, :label_manifest
          
          def initialize field, label_manifest
            @field = field
            @label_manifest = label_manifest
          end
          
          def form
            @field.form
          end
          
          def manifest
            self.form.manifest
          end
          
          def form_name
            self.form.form_name
          end
          
          def model
            self.form.model
          end
          
          def item
            self.form.item
          end
          
          def item_name
            @label_manifest.item_name
          end
          
          def column_name
            @label_manifest.column_name
          end
          
          def template_dir
            self.form.template_dir + 'label/'
          end
          
          def template_file_name
            raise "undefined template_file_name\n"
          end
          
          def template_name
            self.template_dir + self.template_file_name
          end
          
          def label_row_break_template_dir
            self.form.template_dir + 'label_row_break/'
          end
          
          def label_row_break_template_file_name
            if @label_manifest.row_break
              'br'
            else
              'no_break'
            end
          end
          
          def label_row_break_template_name
            self.label_row_break_template_dir + self.label_row_break_template_file_name
          end
          
        end
        
        class Default < Base
          def template_file_name
            'default'
          end
          
          def label_name
            'activerecord.attributes.' + self.item_name + '.' +  self.column_name
          end
          
        end
        
        class None < Base
          def template_file_name
            'none'
          end
          
        end
        
      end
    end
  end
end
