module ManifestBase
  class NameValues
    attr :parent, :name, :json, :module_name
    
    def initialize parent, name, json, module_name
      @parent = parent
      @name = name
      @json = json
      @module_name = module_name
      self.set_default
      self.init
    end
    
    def set_default
      @values = @json
    end
    
    def init
    end
    
    def module_names
      self.parent.module_names + [@module_name, @name]
    end
    
    def module_message
      ManifestBase.module_message(self.module_names)
    end
    
    def parent_name
      @parent.name
    end
    
    def parent_json
      @parent.json
    end
    
  end
end

