# -*- encoding: utf-8 -*-
FactoryGirl.define do
  factory :license_group_pc, :class => LicenseGroup do |i|
    i.name 'PettanCommonsV01Licenses@pettanr'
    i.module_name 'PettanrPettanCommonsV01Licenses'
    i.caption 'Pettan Commons 0.1'
    i.url 'http://sourceforge.jp/projects/pettanr/wiki/PettanCommons'
    trait :with_licenses do
      after(:create) do |lg, evaluator|
        create(:license_pc_by_with_system_picture)
        create(:license_pc_bync_with_system_picture)
        create(:license_pc_bysa_with_system_picture)
        create(:license_pc_byncsa_with_system_picture)
        create(:license_pc_bynd_with_system_picture)
      end
    end
    factory :license_group_pc_with_licenses, traits: [:with_licenses]
  end
  factory :license_group_cc, :class => LicenseGroup do |i|
    i.name 'CreativeCommonsV30Licenses@us'
    i.module_name 'PettanrCreativeCommonsV30Licenses'
    i.caption 'Creative Commons 3.0'
    i.url 'http://creativecommons.org/'
  end
  factory :license_group_ppro, :class => LicenseGroup do |i|
    i.name 'PettanProtected01Licenses@pettanr'
    i.module_name 'PettanrPettanProtectedV01Licenses'
    i.caption 'Pettan Protected 0.1'
    i.url 'https://github.com/yasushiito/pettanr_ppro_v01_licenses/wiki'
  end
  factory :license_group_ppub, :class => LicenseGroup do |i|
    i.name 'PettanPublicV01Licenses@pettanr'
    i.module_name 'PettanrPettanPublicV01Licenses'
    i.caption 'Pettan Public 0.1'
    i.url 'https://github.com/yasushiito/pettanr_ppub_v01_licenses/wiki'
  end
  factory :license_group_pd, :class => LicenseGroup do |i|
    i.name 'PublicDomainV01Licenses@pettanr'
    i.module_name 'PettanrPublicDomainV01Licenses'
    i.caption 'Public Domain 0.1'
    i.url 'https://github.com/yasushiito/pettanr_pd_v01_licenses/wiki'
  end
  factory :license_group_uk, :class => LicenseGroup do |i|
    i.name 'UnknownV01Licenses@pettanr'
    i.module_name 'PettanrUnknownV01Licenses'
    i.caption 'Unknown 0.1'
    i.url 'https://github.com/yasushiito/pettanr_unknown_v01_licenses/wiki'
  end
  factory :license_group_test, :class => LicenseGroup do |i|
    i.name 'TestV01Licenses@pettanr'
    i.module_name 'PettanrTestV01Licenses'
    i.caption 'Test 0.1'
    i.url 'https://github.com/yasushiito/pettanr_test_v01_licenses/wiki'
  end
end
